Merge branch 'ow/rev-parse-is-shallow-repo'
[git] / t / perf / perf-lib.sh
1 # Performance testing framework.  Each perf script starts much like
2 # a normal test script, except it sources this library instead of
3 # test-lib.sh.  See t/perf/README for documentation.
4 #
5 # Copyright (c) 2011 Thomas Rast
6 #
7 # This program is free software: you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation, either version 2 of the License, or
10 # (at your option) any later version.
11 #
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 # GNU General Public License for more details.
16 #
17 # You should have received a copy of the GNU General Public License
18 # along with this program.  If not, see http://www.gnu.org/licenses/ .
19
20 # do the --tee work early; it otherwise confuses our careful
21 # GIT_BUILD_DIR mangling
22 case "$GIT_TEST_TEE_STARTED, $* " in
23 done,*)
24         # do not redirect again
25         ;;
26 *' --tee '*|*' --va'*)
27         mkdir -p test-results
28         BASE=test-results/$(basename "$0" .sh)
29         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
30          echo $? > $BASE.exit) | tee $BASE.out
31         test "$(cat $BASE.exit)" = 0
32         exit
33         ;;
34 esac
35
36 TEST_DIRECTORY=$(pwd)/..
37 TEST_OUTPUT_DIRECTORY=$(pwd)
38 if test -z "$GIT_TEST_INSTALLED"; then
39         perf_results_prefix=
40 else
41         perf_results_prefix=$(printf "%s" "${GIT_TEST_INSTALLED%/bin-wrappers}" | tr -c "[a-zA-Z0-9]" "[_*]")"."
42         # make the tested dir absolute
43         GIT_TEST_INSTALLED=$(cd "$GIT_TEST_INSTALLED" && pwd)
44 fi
45
46 TEST_NO_CREATE_REPO=t
47 TEST_NO_MALLOC_CHECK=t
48
49 . ../test-lib.sh
50
51 # Variables from test-lib that are normally internal to the tests; we
52 # need to export them for test_perf subshells
53 export TEST_DIRECTORY TRASH_DIRECTORY GIT_BUILD_DIR GIT_TEST_CMP
54
55 MODERN_GIT=$GIT_BUILD_DIR/bin-wrappers/git
56 export MODERN_GIT
57
58 perf_results_dir=$TEST_OUTPUT_DIRECTORY/test-results
59 mkdir -p "$perf_results_dir"
60 rm -f "$perf_results_dir"/$(basename "$0" .sh).subtests
61
62 if test -z "$GIT_PERF_REPEAT_COUNT"; then
63         GIT_PERF_REPEAT_COUNT=3
64 fi
65 die_if_build_dir_not_repo () {
66         if ! ( cd "$TEST_DIRECTORY/.." &&
67                     git rev-parse --build-dir >/dev/null 2>&1 ); then
68                 error "No $1 defined, and your build directory is not a repo"
69         fi
70 }
71
72 if test -z "$GIT_PERF_REPO"; then
73         die_if_build_dir_not_repo '$GIT_PERF_REPO'
74         GIT_PERF_REPO=$TEST_DIRECTORY/..
75 fi
76 if test -z "$GIT_PERF_LARGE_REPO"; then
77         die_if_build_dir_not_repo '$GIT_PERF_LARGE_REPO'
78         GIT_PERF_LARGE_REPO=$TEST_DIRECTORY/..
79 fi
80
81 test_perf_do_repo_symlink_config_ () {
82         test_have_prereq SYMLINKS || git config core.symlinks false
83 }
84
85 test_perf_create_repo_from () {
86         test "$#" = 2 ||
87         error "bug in the test script: not 2 parameters to test-create-repo"
88         repo="$1"
89         source="$2"
90         source_git="$("$MODERN_GIT" -C "$source" rev-parse --git-dir)"
91         objects_dir="$("$MODERN_GIT" -C "$source" rev-parse --git-path objects)"
92         mkdir -p "$repo/.git"
93         (
94                 cd "$source" &&
95                 { cp -Rl "$objects_dir" "$repo/.git/" 2>/dev/null ||
96                         cp -R "$objects_dir" "$repo/.git/"; } &&
97                 for stuff in "$source_git"/*; do
98                         case "$stuff" in
99                                 */objects|*/hooks|*/config|*/commondir)
100                                         ;;
101                                 *)
102                                         cp -R "$stuff" "$repo/.git/" || exit 1
103                                         ;;
104                         esac
105                 done
106         ) &&
107         (
108                 cd "$repo" &&
109                 "$MODERN_GIT" init -q &&
110                 test_perf_do_repo_symlink_config_ &&
111                 mv .git/hooks .git/hooks-disabled 2>/dev/null &&
112                 if test -f .git/index.lock
113                 then
114                         # We may be copying a repo that can't run "git
115                         # status" due to a locked index. Since we have
116                         # a copy it's fine to remove the lock.
117                         rm .git/index.lock
118                 fi
119         ) || error "failed to copy repository '$source' to '$repo'"
120 }
121
122 # call at least one of these to establish an appropriately-sized repository
123 test_perf_fresh_repo () {
124         repo="${1:-$TRASH_DIRECTORY}"
125         "$MODERN_GIT" init -q "$repo" &&
126         (
127                 cd "$repo" &&
128                 test_perf_do_repo_symlink_config_
129         )
130 }
131
132 test_perf_default_repo () {
133         test_perf_create_repo_from "${1:-$TRASH_DIRECTORY}" "$GIT_PERF_REPO"
134 }
135 test_perf_large_repo () {
136         if test "$GIT_PERF_LARGE_REPO" = "$GIT_BUILD_DIR"; then
137                 echo "warning: \$GIT_PERF_LARGE_REPO is \$GIT_BUILD_DIR." >&2
138                 echo "warning: This will work, but may not be a sufficiently large repo" >&2
139                 echo "warning: for representative measurements." >&2
140         fi
141         test_perf_create_repo_from "${1:-$TRASH_DIRECTORY}" "$GIT_PERF_LARGE_REPO"
142 }
143 test_checkout_worktree () {
144         git checkout-index -u -a ||
145         error "git checkout-index failed"
146 }
147
148 # Performance tests should never fail.  If they do, stop immediately
149 immediate=t
150
151 # Perf tests require GNU time
152 case "$(uname -s)" in Darwin) GTIME="${GTIME:-gtime}";; esac
153 GTIME="${GTIME:-/usr/bin/time}"
154
155 test_run_perf_ () {
156         test_cleanup=:
157         test_export_="test_cleanup"
158         export test_cleanup test_export_
159         "$GTIME" -f "%E %U %S" -o test_time.$i "$SHELL" -c '
160 . '"$TEST_DIRECTORY"/test-lib-functions.sh'
161 test_export () {
162         [ $# != 0 ] || return 0
163         test_export_="$test_export_\\|$1"
164         shift
165         test_export "$@"
166 }
167 '"$1"'
168 ret=$?
169 set | sed -n "s'"/'/'\\\\''/g"';s/^\\($test_export_\\)/export '"'&'"'/p" >test_vars
170 exit $ret' >&3 2>&4
171         eval_ret=$?
172
173         if test $eval_ret = 0 || test -n "$expecting_failure"
174         then
175                 test_eval_ "$test_cleanup"
176                 . ./test_vars || error "failed to load updated environment"
177         fi
178         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
179                 echo ""
180         fi
181         return "$eval_ret"
182 }
183
184
185 test_perf () {
186         test_start_
187         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
188         test "$#" = 2 ||
189         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
190         export test_prereq
191         if ! test_skip "$@"
192         then
193                 base=$(basename "$0" .sh)
194                 echo "$test_count" >>"$perf_results_dir"/$base.subtests
195                 echo "$1" >"$perf_results_dir"/$base.$test_count.descr
196                 if test -z "$verbose"; then
197                         printf "%s" "perf $test_count - $1:"
198                 else
199                         echo "perf $test_count - $1:"
200                 fi
201                 for i in $(test_seq 1 $GIT_PERF_REPEAT_COUNT); do
202                         say >&3 "running: $2"
203                         if test_run_perf_ "$2"
204                         then
205                                 if test -z "$verbose"; then
206                                         printf " %s" "$i"
207                                 else
208                                         echo "* timing run $i/$GIT_PERF_REPEAT_COUNT:"
209                                 fi
210                         else
211                                 test -z "$verbose" && echo
212                                 test_failure_ "$@"
213                                 break
214                         fi
215                 done
216                 if test -z "$verbose"; then
217                         echo " ok"
218                 else
219                         test_ok_ "$1"
220                 fi
221                 base="$perf_results_dir"/"$perf_results_prefix$(basename "$0" .sh)"."$test_count"
222                 "$TEST_DIRECTORY"/perf/min_time.perl test_time.* >"$base".times
223         fi
224         test_finish_
225 }
226
227 # We extend test_done to print timings at the end (./run disables this
228 # and does it after running everything)
229 test_at_end_hook_ () {
230         if test -z "$GIT_PERF_AGGREGATING_LATER"; then
231                 ( cd "$TEST_DIRECTORY"/perf && ./aggregate.perl $(basename "$0") )
232         fi
233 }
234
235 test_export () {
236         export "$@"
237 }